#!/usr/bin/env python

#	Skymeter, raadpleegt de Volumepagina van skynet selfcare,
#	verwerkt deze en bekomt de nuttige informatie.
#	
#	Copyright (C) 2005 Thomas Langewouters. 
#	
#	This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#	
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import re
import urllib2
import urllib

class skymetererror:
	def __init__(self, errorstring):
		self.error = errorstring

class skymeter:
	def GetData(self):
		baseurl = "https://e-care.skynet.be/index.cfm"
		postdata =  {	"form_login" :		self.username,
				"form_password":	self.password,
				"Langue_Id":		"2",
				"fuseaction":		"CheckLoginConnection"	
			    }
		try:
			f = urllib2.urlopen(
				baseurl +"?"+urllib.urlencode({"function": "connection.getVolume"}), 
				urllib.urlencode(postdata)
			) 
		except:
			return skymetererror("Verbindingsfout")
		buffer = f.read()
		f.close()
		
		if buffer.find("Basic monthly volume:") == -1:
			# TODO: controleer wat de fout is...
			return skymetererror("Fout wachtwoord")
	
		basic = re.compile(r"\s*(\d*\.*\d*)\s*GB<\/strong> out of <strong>(\d+)\s+GB").search(buffer).groups()
		
		if buffer.find("Volume Pack in current use: ") != -1:
			try:
				vpack = re.compile(r"You used <strong>\s*(\d*\.*\d*) GB<\/strong><\/font> out of &nbsp;<strong>(\d+) GB<\/strong> available in the current Volume Pack").search(buffer).groups()
			except:
				vpack = []
		else:
			vpack = []
		basicnum = []
		vpacknum = []
		for num in basic:
			basicnum.append(float(num))
		for numr in vpack:
			vpacknum.append(float(numr))
		return { "basic" : basicnum, "pack": vpacknum }	

